
const
  SDLK_SCANCODE_MASK = 1 shl 30;

SDLK_UNKNOWN = 0;
	SDLK_RETURN = Integer(#13);   // C: '\r'
	SDLK_ESCAPE = Integer(#27);   // C: '\033'
	SDLK_BACKSPACE = Integer(#8){%H-}; // C: '\b'
	SDLK_TAB = Integer(#9);       // C: '\t'
	SDLK_SPACE = Integer(' ');
	SDLK_EXCLAIM = Integer('!');
	SDLK_QUOTEDBL = Integer('"');
	SDLK_HASH = Integer('#');
	SDLK_PERCENT = Integer('%');
	SDLK_DOLLAR = Integer('$');
	SDLK_AMPERSAND = Integer('&');
	SDLK_QUOTE = Integer('\');
	SDLK_LEFTPAREN = Integer('(');
	SDLK_RIGHTPAREN = Integer(')');
	SDLK_ASTERISK = Integer('*');
	SDLK_PLUS = Integer('+');
	SDLK_COMMA = Integer(';');
	SDLK_MINUS = Integer('-');
	SDLK_PERIOD = Integer('.');
	SDLK_SLASH = Integer('/');
	SDLK_0 = Integer('0');
	SDLK_1 = Integer('1');
	SDLK_2 = Integer('2');
	SDLK_3 = Integer('3');
	SDLK_4 = Integer('4');
	SDLK_5 = Integer('5');
	SDLK_6 = Integer('6');
	SDLK_7 = Integer('7');
	SDLK_8 = Integer('8');
	SDLK_9 = Integer('9');
	SDLK_COLON = Integer(':');
	SDLK_SEMICOLON = Integer(';');
	SDLK_LESS = Integer('<');
	SDLK_EQUALS = Integer('=');
	SDLK_GREATER = Integer('>');
	SDLK_QUESTION = Integer('?');
	SDLK_AT = Integer('@');
	(*
	   Skip uppercase letters
	 *)
	SDLK_LEFTBRACKET = Integer('[');
	SDLK_BACKSLASH = Integer('\');
	SDLK_RIGHTBRACKET = Integer(']');
	SDLK_CARET = Integer('^');
	SDLK_UNDERSCORE = Integer('_');
	SDLK_BACKQUOTE = Integer('`');
	SDLK_a = Integer('a');
	SDLK_b = Integer('b');
	SDLK_c = Integer('c');
	SDLK_d = Integer('d');
	SDLK_e = Integer('e');
	SDLK_f = Integer('f');
	SDLK_g = Integer('g');
	SDLK_h = Integer('h');
	SDLK_i = Integer('i');
	SDLK_j = Integer('j');
	SDLK_k = Integer('k');
	SDLK_l = Integer('l');
	SDLK_m = Integer('m');
	SDLK_n = Integer('n');
	SDLK_o = Integer('o');
	SDLK_p = Integer('p');
	SDLK_q = Integer('q');
	SDLK_r = Integer('r');
	SDLK_s = Integer('s');
	SDLK_t = Integer('t');
	SDLK_u = Integer('u');
	SDLK_v = Integer('v');
	SDLK_w = Integer('w');
	SDLK_x = Integer('x');
	SDLK_y = Integer('y');
	SDLK_z = Integer('z');

	SDLK_CAPSLOCK = Integer(SDL_SCANCODE_CAPSLOCK) or SDLK_SCANCODE_MASK;

	SDLK_F1 = Integer(SDL_SCANCODE_F1) or SDLK_SCANCODE_MASK;
	SDLK_F2 = Integer(SDL_SCANCODE_F2) or SDLK_SCANCODE_MASK;
	SDLK_F3 = Integer(SDL_SCANCODE_F3) or SDLK_SCANCODE_MASK;
	SDLK_F4 = Integer(SDL_SCANCODE_F4) or SDLK_SCANCODE_MASK;
	SDLK_F5 = Integer(SDL_SCANCODE_F5) or SDLK_SCANCODE_MASK;
	SDLK_F6 = Integer(SDL_SCANCODE_F6) or SDLK_SCANCODE_MASK;
	SDLK_F7 = Integer(SDL_SCANCODE_F7) or SDLK_SCANCODE_MASK;
	SDLK_F8 = Integer(SDL_SCANCODE_F8) or SDLK_SCANCODE_MASK;
	SDLK_F9 = Integer(SDL_SCANCODE_F9) or SDLK_SCANCODE_MASK;
	SDLK_F10 = Integer(SDL_SCANCODE_F10) or SDLK_SCANCODE_MASK;
	SDLK_F11 = Integer(SDL_SCANCODE_F11) or SDLK_SCANCODE_MASK;
	SDLK_F12 = Integer(SDL_SCANCODE_F12) or SDLK_SCANCODE_MASK;

	SDLK_PRINTSCREEN = Integer(SDL_SCANCODE_PRINTSCREEN) or SDLK_SCANCODE_MASK;
	SDLK_SCROLLLOCK = Integer(SDL_SCANCODE_SCROLLLOCK) or SDLK_SCANCODE_MASK;
	SDLK_PAUSE = Integer(SDL_SCANCODE_PAUSE) or SDLK_SCANCODE_MASK;
	SDLK_INSERT = Integer(SDL_SCANCODE_INSERT) or SDLK_SCANCODE_MASK;
	SDLK_HOME = Integer(SDL_SCANCODE_HOME) or SDLK_SCANCODE_MASK;
	SDLK_PAGEUP = Integer(SDL_SCANCODE_PAGEUP) or SDLK_SCANCODE_MASK;
	SDLK_DELETE = Integer(#127); // C: '\177'
	SDLK_END = Integer(SDL_SCANCODE_END) or SDLK_SCANCODE_MASK;
	SDLK_PAGEDOWN = Integer(SDL_SCANCODE_PAGEDOWN) or SDLK_SCANCODE_MASK;
	SDLK_RIGHT = Integer(SDL_SCANCODE_RIGHT) or SDLK_SCANCODE_MASK;
	SDLK_LEFT = Integer(SDL_SCANCODE_LEFT) or SDLK_SCANCODE_MASK;
	SDLK_DOWN = Integer(SDL_SCANCODE_DOWN) or SDLK_SCANCODE_MASK;
	SDLK_UP = Integer(SDL_SCANCODE_UP) or SDLK_SCANCODE_MASK;

	SDLK_NUMLOCKCLEAR = Integer(SDL_SCANCODE_NUMLOCKCLEAR) or SDLK_SCANCODE_MASK;
	SDLK_KP_DIVIDE = Integer(SDL_SCANCODE_KP_DIVIDE) or SDLK_SCANCODE_MASK;
	SDLK_KP_MULTIPLY = Integer(SDL_SCANCODE_KP_MULTIPLY) or SDLK_SCANCODE_MASK;
	SDLK_KP_MINUS = Integer(SDL_SCANCODE_KP_MINUS) or SDLK_SCANCODE_MASK;
	SDLK_KP_PLUS = Integer(SDL_SCANCODE_KP_PLUS) or SDLK_SCANCODE_MASK;
	SDLK_KP_ENTER = Integer(SDL_SCANCODE_KP_ENTER) or SDLK_SCANCODE_MASK;
	SDLK_KP_1 = Integer(SDL_SCANCODE_KP_1) or SDLK_SCANCODE_MASK;
	SDLK_KP_2 = Integer(SDL_SCANCODE_KP_2) or SDLK_SCANCODE_MASK;
	SDLK_KP_3 = Integer(SDL_SCANCODE_KP_3) or SDLK_SCANCODE_MASK;
	SDLK_KP_4 = Integer(SDL_SCANCODE_KP_4) or SDLK_SCANCODE_MASK;
	SDLK_KP_5 = Integer(SDL_SCANCODE_KP_5) or SDLK_SCANCODE_MASK;
	SDLK_KP_6 = Integer(SDL_SCANCODE_KP_6) or SDLK_SCANCODE_MASK;
	SDLK_KP_7 = Integer(SDL_SCANCODE_KP_7) or SDLK_SCANCODE_MASK;
	SDLK_KP_8 = Integer(SDL_SCANCODE_KP_8) or SDLK_SCANCODE_MASK;
	SDLK_KP_9 = Integer(SDL_SCANCODE_KP_9) or SDLK_SCANCODE_MASK;
	SDLK_KP_0 = Integer(SDL_SCANCODE_KP_0) or SDLK_SCANCODE_MASK;
	SDLK_KP_PERIOD = Integer(SDL_SCANCODE_KP_PERIOD) or SDLK_SCANCODE_MASK;

	SDLK_APPLICATION = Integer(SDL_SCANCODE_APPLICATION) or SDLK_SCANCODE_MASK;
	SDLK_POWER = Integer(SDL_SCANCODE_POWER) or SDLK_SCANCODE_MASK;
	SDLK_KP_EQUALS = Integer(SDL_SCANCODE_KP_EQUALS) or SDLK_SCANCODE_MASK;
	SDLK_F13 = Integer(SDL_SCANCODE_F13) or SDLK_SCANCODE_MASK;
	SDLK_F14 = Integer(SDL_SCANCODE_F14) or SDLK_SCANCODE_MASK;
	SDLK_F15 = Integer(SDL_SCANCODE_F15) or SDLK_SCANCODE_MASK;
	SDLK_F16 = Integer(SDL_SCANCODE_F16) or SDLK_SCANCODE_MASK;
	SDLK_F17 = Integer(SDL_SCANCODE_F17) or SDLK_SCANCODE_MASK;
	SDLK_F18 = Integer(SDL_SCANCODE_F18) or SDLK_SCANCODE_MASK;
	SDLK_F19 = Integer(SDL_SCANCODE_F19) or SDLK_SCANCODE_MASK;
	SDLK_F20 = Integer(SDL_SCANCODE_F20) or SDLK_SCANCODE_MASK;
	SDLK_F21 = Integer(SDL_SCANCODE_F21) or SDLK_SCANCODE_MASK;
	SDLK_F22 = Integer(SDL_SCANCODE_F22) or SDLK_SCANCODE_MASK;
	SDLK_F23 = Integer(SDL_SCANCODE_F23) or SDLK_SCANCODE_MASK;
	SDLK_F24 = Integer(SDL_SCANCODE_F24) or SDLK_SCANCODE_MASK;
	SDLK_EXECUTE = Integer(SDL_SCANCODE_EXECUTE) or SDLK_SCANCODE_MASK;
	SDLK_HELP = Integer(SDL_SCANCODE_HELP) or SDLK_SCANCODE_MASK;
	SDLK_MENU = Integer(SDL_SCANCODE_MENU) or SDLK_SCANCODE_MASK;
	SDLK_SELECT = Integer(SDL_SCANCODE_SELECT) or SDLK_SCANCODE_MASK;
	SDLK_STOP = Integer(SDL_SCANCODE_STOP) or SDLK_SCANCODE_MASK;
	SDLK_AGAIN = Integer(SDL_SCANCODE_AGAIN) or SDLK_SCANCODE_MASK;
	SDLK_UNDO = Integer(SDL_SCANCODE_UNDO) or SDLK_SCANCODE_MASK;
	SDLK_CUT = Integer(SDL_SCANCODE_CUT) or SDLK_SCANCODE_MASK;
	SDLK_COPY = Integer(SDL_SCANCODE_COPY) or SDLK_SCANCODE_MASK;
	SDLK_PASTE = Integer(SDL_SCANCODE_PASTE) or SDLK_SCANCODE_MASK;
	SDLK_FIND = Integer(SDL_SCANCODE_FIND) or SDLK_SCANCODE_MASK;
	SDLK_MUTE = Integer(SDL_SCANCODE_MUTE) or SDLK_SCANCODE_MASK;
	SDLK_VOLUMEUP = Integer(SDL_SCANCODE_VOLUMEUP) or SDLK_SCANCODE_MASK;
	SDLK_VOLUMEDOWN = Integer(SDL_SCANCODE_VOLUMEDOWN) or SDLK_SCANCODE_MASK;
	SDLK_KP_COMMA = Integer(SDL_SCANCODE_KP_COMMA) or SDLK_SCANCODE_MASK;
	SDLK_KP_EQUALSAS400 = Integer(SDL_SCANCODE_KP_EQUALSAS400) or SDLK_SCANCODE_MASK;

	SDLK_ALTERASE = Integer(SDL_SCANCODE_ALTERASE) or SDLK_SCANCODE_MASK;
	SDLK_SYSREQ = Integer(SDL_SCANCODE_SYSREQ) or SDLK_SCANCODE_MASK;
	SDLK_CANCEL = Integer(SDL_SCANCODE_CANCEL) or SDLK_SCANCODE_MASK;
	SDLK_CLEAR = Integer(SDL_SCANCODE_CLEAR) or SDLK_SCANCODE_MASK;
	SDLK_PRIOR = Integer(SDL_SCANCODE_PRIOR) or SDLK_SCANCODE_MASK;
	SDLK_RETURN2 = Integer(SDL_SCANCODE_RETURN2) or SDLK_SCANCODE_MASK;
	SDLK_SEPARATOR = Integer(SDL_SCANCODE_SEPARATOR) or SDLK_SCANCODE_MASK;
	SDLK_OUT = Integer(SDL_SCANCODE_OUT) or SDLK_SCANCODE_MASK;
	SDLK_OPER = Integer(SDL_SCANCODE_OPER) or SDLK_SCANCODE_MASK;
	SDLK_CLEARAGAIN = Integer(SDL_SCANCODE_CLEARAGAIN) or SDLK_SCANCODE_MASK;
	SDLK_CRSEL = Integer(SDL_SCANCODE_CRSEL) or SDLK_SCANCODE_MASK;
	SDLK_EXSEL = Integer(SDL_SCANCODE_EXSEL) or SDLK_SCANCODE_MASK;

	SDLK_KP_00 = Integer(SDL_SCANCODE_KP_00) or SDLK_SCANCODE_MASK;
	SDLK_KP_000 = Integer(SDL_SCANCODE_KP_000) or SDLK_SCANCODE_MASK;
	SDLK_THOUSANDSSEPARATOR = Integer(SDL_SCANCODE_THOUSANDSSEPARATOR) or SDLK_SCANCODE_MASK;
	SDLK_DECIMALSEPARATOR = Integer(SDL_SCANCODE_DECIMALSEPARATOR) or SDLK_SCANCODE_MASK;
	SDLK_CURRENCYUNIT = Integer(SDL_SCANCODE_CURRENCYUNIT) or SDLK_SCANCODE_MASK;
	SDLK_CURRENCYSUBUNIT = Integer(SDL_SCANCODE_CURRENCYSUBUNIT) or SDLK_SCANCODE_MASK;
	SDLK_KP_LEFTPAREN = Integer(SDL_SCANCODE_KP_LEFTPAREN) or SDLK_SCANCODE_MASK;
	SDLK_KP_RIGHTPAREN = Integer(SDL_SCANCODE_KP_RIGHTPAREN) or SDLK_SCANCODE_MASK;
	SDLK_KP_LEFTBRACE = Integer(SDL_SCANCODE_KP_LEFTBRACE) or SDLK_SCANCODE_MASK;
	SDLK_KP_RIGHTBRACE = Integer(SDL_SCANCODE_KP_RIGHTBRACE) or SDLK_SCANCODE_MASK;
	SDLK_KP_TAB = Integer(SDL_SCANCODE_KP_TAB) or SDLK_SCANCODE_MASK;
	SDLK_KP_BACKSPACE = Integer(SDL_SCANCODE_KP_BACKSPACE) or SDLK_SCANCODE_MASK;
	SDLK_KP_A = Integer(SDL_SCANCODE_KP_A) or SDLK_SCANCODE_MASK;
	SDLK_KP_B = Integer(SDL_SCANCODE_KP_B) or SDLK_SCANCODE_MASK;
	SDLK_KP_C = Integer(SDL_SCANCODE_KP_C) or SDLK_SCANCODE_MASK;
	SDLK_KP_D = Integer(SDL_SCANCODE_KP_D) or SDLK_SCANCODE_MASK;
	SDLK_KP_E = Integer(SDL_SCANCODE_KP_E) or SDLK_SCANCODE_MASK;
	SDLK_KP_F = Integer(SDL_SCANCODE_KP_F) or SDLK_SCANCODE_MASK;
	SDLK_KP_XOR = Integer(SDL_SCANCODE_KP_XOR) or SDLK_SCANCODE_MASK;
	SDLK_KP_POWER = Integer(SDL_SCANCODE_KP_POWER) or SDLK_SCANCODE_MASK;
	SDLK_KP_PERCENT = Integer(SDL_SCANCODE_KP_PERCENT) or SDLK_SCANCODE_MASK;
	SDLK_KP_LESS = Integer(SDL_SCANCODE_KP_LESS) or SDLK_SCANCODE_MASK;
	SDLK_KP_GREATER = Integer(SDL_SCANCODE_KP_GREATER) or SDLK_SCANCODE_MASK;
	SDLK_KP_AMPERSAND = Integer(SDL_SCANCODE_KP_AMPERSAND) or SDLK_SCANCODE_MASK;
	SDLK_KP_DBLAMPERSAND = Integer(SDL_SCANCODE_KP_DBLAMPERSAND) or SDLK_SCANCODE_MASK;
	SDLK_KP_VERTICALBAR = Integer(SDL_SCANCODE_KP_VERTICALBAR) or SDLK_SCANCODE_MASK;
	SDLK_KP_DBLVERTICALBAR = Integer(SDL_SCANCODE_KP_DBLVERTICALBAR) or SDLK_SCANCODE_MASK;
	SDLK_KP_COLON = Integer(SDL_SCANCODE_KP_COLON) or SDLK_SCANCODE_MASK;
	SDLK_KP_HASH = Integer(SDL_SCANCODE_KP_HASH) or SDLK_SCANCODE_MASK;
	SDLK_KP_SPACE = Integer(SDL_SCANCODE_KP_SPACE) or SDLK_SCANCODE_MASK;
	SDLK_KP_AT = Integer(SDL_SCANCODE_KP_AT) or SDLK_SCANCODE_MASK;
	SDLK_KP_EXCLAM = Integer(SDL_SCANCODE_KP_EXCLAM) or SDLK_SCANCODE_MASK;
	SDLK_KP_MEMSTORE = Integer(SDL_SCANCODE_KP_MEMSTORE) or SDLK_SCANCODE_MASK;
	SDLK_KP_MEMRECALL = Integer(SDL_SCANCODE_KP_MEMRECALL) or SDLK_SCANCODE_MASK;
	SDLK_KP_MEMCLEAR = Integer(SDL_SCANCODE_KP_MEMCLEAR) or SDLK_SCANCODE_MASK;
	SDLK_KP_MEMADD = Integer(SDL_SCANCODE_KP_MEMADD) or SDLK_SCANCODE_MASK;
	SDLK_KP_MEMSUBTRACT = Integer(SDL_SCANCODE_KP_MEMSUBTRACT) or SDLK_SCANCODE_MASK;
	SDLK_KP_MEMMULTIPLY = Integer(SDL_SCANCODE_KP_MEMMULTIPLY) or SDLK_SCANCODE_MASK;
	SDLK_KP_MEMDIVIDE = Integer(SDL_SCANCODE_KP_MEMDIVIDE) or SDLK_SCANCODE_MASK;
	SDLK_KP_PLUSMINUS = Integer(SDL_SCANCODE_KP_PLUSMINUS) or SDLK_SCANCODE_MASK;
	SDLK_KP_CLEAR = Integer(SDL_SCANCODE_KP_CLEAR) or SDLK_SCANCODE_MASK;
	SDLK_KP_CLEARENTRY = Integer(SDL_SCANCODE_KP_CLEARENTRY) or SDLK_SCANCODE_MASK;
	SDLK_KP_BINARY = Integer(SDL_SCANCODE_KP_BINARY) or SDLK_SCANCODE_MASK;
	SDLK_KP_OCTAL = Integer(SDL_SCANCODE_KP_OCTAL) or SDLK_SCANCODE_MASK;
	SDLK_KP_DECIMAL = Integer(SDL_SCANCODE_KP_DECIMAL) or SDLK_SCANCODE_MASK;
	SDLK_KP_HEXADECIMAL = Integer(SDL_SCANCODE_KP_HEXADECIMAL) or SDLK_SCANCODE_MASK;

	SDLK_LCTRL = Integer(SDL_SCANCODE_LCTRL) or SDLK_SCANCODE_MASK;
	SDLK_LSHIFT = Integer(SDL_SCANCODE_LSHIFT) or SDLK_SCANCODE_MASK;
	SDLK_LALT = Integer(SDL_SCANCODE_LALT) or SDLK_SCANCODE_MASK;
	SDLK_LGUI = Integer(SDL_SCANCODE_LGUI) or SDLK_SCANCODE_MASK;
	SDLK_RCTRL = Integer(SDL_SCANCODE_RCTRL) or SDLK_SCANCODE_MASK;
	SDLK_RSHIFT = Integer(SDL_SCANCODE_RSHIFT) or SDLK_SCANCODE_MASK;
	SDLK_RALT = Integer(SDL_SCANCODE_RALT) or SDLK_SCANCODE_MASK;
	SDLK_RGUI = Integer(SDL_SCANCODE_RGUI) or SDLK_SCANCODE_MASK;

	SDLK_MODE = Integer(SDL_SCANCODE_MODE) or SDLK_SCANCODE_MASK;

	SDLK_AUDIONEXT = Integer(SDL_SCANCODE_AUDIONEXT) or SDLK_SCANCODE_MASK;
	SDLK_AUDIOPREV = Integer(SDL_SCANCODE_AUDIOPREV) or SDLK_SCANCODE_MASK;
	SDLK_AUDIOSTOP = Integer(SDL_SCANCODE_AUDIOSTOP) or SDLK_SCANCODE_MASK;
	SDLK_AUDIOPLAY = Integer(SDL_SCANCODE_AUDIOPLAY) or SDLK_SCANCODE_MASK;
	SDLK_AUDIOMUTE = Integer(SDL_SCANCODE_AUDIOMUTE) or SDLK_SCANCODE_MASK;
	SDLK_MEDIASELECT = Integer(SDL_SCANCODE_MEDIASELECT) or SDLK_SCANCODE_MASK;
	SDLK_WWW = Integer(SDL_SCANCODE_WWW) or SDLK_SCANCODE_MASK;
	SDLK_MAIL = Integer(SDL_SCANCODE_MAIL) or SDLK_SCANCODE_MASK;
	SDLK_CALCULATOR = Integer(SDL_SCANCODE_CALCULATOR) or SDLK_SCANCODE_MASK;
	SDLK_COMPUTER = Integer(SDL_SCANCODE_COMPUTER) or SDLK_SCANCODE_MASK;
	SDLK_AC_SEARCH = Integer(SDL_SCANCODE_AC_SEARCH) or SDLK_SCANCODE_MASK;
	SDLK_AC_HOME = Integer(SDL_SCANCODE_AC_HOME) or SDLK_SCANCODE_MASK;
	SDLK_AC_BACK = Integer(SDL_SCANCODE_AC_BACK) or SDLK_SCANCODE_MASK;
	SDLK_AC_FORWARD = Integer(SDL_SCANCODE_AC_FORWARD) or SDLK_SCANCODE_MASK;
	SDLK_AC_STOP = Integer(SDL_SCANCODE_AC_STOP) or SDLK_SCANCODE_MASK;
	SDLK_AC_REFRESH = Integer(SDL_SCANCODE_AC_REFRESH) or SDLK_SCANCODE_MASK;
	SDLK_AC_BOOKMARKS = Integer(SDL_SCANCODE_AC_BOOKMARKS) or SDLK_SCANCODE_MASK;

	SDLK_BRIGHTNESSDOWN = Integer(SDL_SCANCODE_BRIGHTNESSDOWN) or SDLK_SCANCODE_MASK;
	SDLK_BRIGHTNESSUP = Integer(SDL_SCANCODE_BRIGHTNESSUP) or SDLK_SCANCODE_MASK;
	SDLK_DISPLAYSWITCH = Integer(SDL_SCANCODE_DISPLAYSWITCH) or SDLK_SCANCODE_MASK;
	SDLK_KBDILLUMTOGGLE = Integer(SDL_SCANCODE_KBDILLUMTOGGLE) or SDLK_SCANCODE_MASK;
	SDLK_KBDILLUMDOWN = Integer(SDL_SCANCODE_KBDILLUMDOWN) or SDLK_SCANCODE_MASK;
	SDLK_KBDILLUMUP = Integer(SDL_SCANCODE_KBDILLUMUP) or SDLK_SCANCODE_MASK;
	SDLK_EJECT = Integer(SDL_SCANCODE_EJECT) or SDLK_SCANCODE_MASK;
	SDLK_SLEEP = Integer(SDL_SCANCODE_SLEEP) or SDLK_SCANCODE_MASK;


type
  PSDL_KeyCode = ^SDL_KeyCode;

  SDL_Keycode = Integer;

  (**
   * \brief Enumeration of valid key mods (possibly OR'd together).
   *)
  {$PackEnum 2}
  SDL_Keymod = (
      KMOD_NONE = $0000,
      KMOD_LSHIFT = $0001,
      KMOD_RSHIFT = $0002,
      KMOD_LCTRL = $0040,
      KMOD_RCTRL = $0080,
      KMOD_LALT = $0100,
      KMOD_RALT = $0200,
      KMOD_LGUI = $0400,
      KMOD_RGUI = $0800,
      KMOD_NUM = $1000,
      KMOD_CAPS = $2000,
      KMOD_MODE = $4000,
      KMOD_RESERVED = $8000
  );
  {$PackEnum 4}

  SDL_Keymods = record Value: SDL_UInt32; end;

const
  KMOD_CTRL  = Integer(KMOD_LCTRL)  or Integer(KMOD_RCTRL);
  KMOD_SHIFT = Integer(KMOD_LSHIFT) or Integer(KMOD_RSHIFT);
  KMOD_ALT   = Integer(KMOD_LALT)   or Integer(KMOD_RALT);
  KMOD_GUI   = Integer(KMOD_LGUI)   or Integer(KMOD_RGUI);
